;*******************************************
;PROGRAMOVATELN INTERFACE STROJE - ZKUEBN
;KOLEN MEFI 2003 (dual)
;Definice maker (uivatelskch instrukc)
;*******************************************

CONTROL_T_MACRO pos

;.......

;Definice uivatelsk instrukce LOD1, kter provd
;podmnn ten buky do DR v ppad, e RLO je 1.
DEF_T_MACRO LOD1 p1
T_LOCAL	END_LOD1

	JL0		END_LOD1
	LOD		TMAC.p1
END_LOD1:

END_T_MACRO T_NORMAL, C_0, D_ON


;.......

;Definice uivatelsk instrukce EDGESET, kter testuje
;signl Sig a pi nbn hran nastav Mech na 1.
DEF_T_MACRO EDGESET Sig, Mech
	T_LOCAL LocData, SigMin, b2, b3, b4, b5, b6, b7, b8
	DATA_LOCAL
		LocData:	DFM SigMin, b2, b3, b4, b5, b6, b7, b8
	DATA_LOCAL_END

	LDR		tmac.Sig		;test hrany signalu
	LA		-SigMin
	FL1		1,tmac.Mech		;aktivace mechanizmu RETEZ1
	LDR		tmac.Sig
	WR		SigMin

END_T_MACRO t_normal, c_0, d_on

;.......

;Definice uivatelsk instrukce EDGEINV, kter testuje
;signl Sig a pi nbn hran RLO invertuje bit Par
DEF_T_MACRO EDGEINV  Par
	T_LOCAL LocData, SigMin, Sig, b3, b4, b5, b6, b7, b8
	T_LOCAL NavMac
	DATA_LOCAL
		LocData:	DFM SigMin, Sig, b3, b4, b5, b6, b7, b8
	DATA_LOCAL_END

	WR		Sig			;test hrany signalu
	LA		-SigMin
	JL0		NavMac
	LDR		-tmac.Par
	WR		tmac.Par
NavMac:
	LDR		Sig
	WR		SigMin

END_T_MACRO t_normal, c_0, d_on

;.......

;Instrukce pro definici prikazu Autogen-Plazma
DEF_T_MACRO CMD_SUPORT  SUPORT,AUTOGEN,PLAZMA
		LA			CNFOK
		WR			CNFOK
		LOD			TMAC.SUPORT
		EQ			CNST.1					;Autogen ?
		LOD			DWRD.BUN_DWORD
		STO1		DWRD.AUTOGEN
		LOD			TMAC.SUPORT
		EQ			CNST.2					;Plazma ?
		LOD			DWRD.BUN_DWORD
		STO1		DWRD.PLAZMA
END_T_MACRO t_normal, c_0, d_on

;........

;Prevod casu [s] z REAL do WORD v taktu [20ms]
DEF_T_MACRO REAL_TIME20MS B_REAL,B_WORD
		cli
		finit
		fld		qword ptr B_REAL
		fimul	word ptr BW50
		fistp	word ptr B_WORD
		sti  
END_T_MACRO t_normal, c_0, d_on

;........

;Prevod z REAL do WORD primo
DEF_T_MACRO REAL_INT B_REAL,B_WORD
		cli
		finit
		fld		qword ptr B_REAL
		fistp	word ptr B_WORD
		sti  
END_T_MACRO t_normal, c_0, d_on

;........

;Prevod tlaku REAL [kPa] do WORD na [bar*1000]
;100kPa = 1bar
;(1600kPa = 16000 bar*1000)
DEF_T_MACRO REAL_TLAK B_REAL,B_WORD1,B_WORD2,MAXTLAK
		cli
		finit
		fld		qword ptr B_REAL
		fimul	word ptr BW10
		fist	word ptr B_WORD1
		fimul	word ptr MAX_VOLT
		fidiv	word ptr MAXTLAK
		fistp	word ptr B_WORD2
		sti  
END_T_MACRO t_normal, c_0, d_on

;........

;Prevod miry [mm] z REAL do DWORD na [um]
DEF_T_MACRO REAL_MM B_REAL,B_WORD
		cli
		finit
		fld		qword ptr B_REAL
		fimul	word ptr BW1000
		fistp	dword ptr B_WORD
		sti  
END_T_MACRO t_normal, c_0, d_on

;........

;Prevod rychlosti [mm/min] z REAL do DWORD na [1/64000 mm/min (POS)]
DEF_T_MACRO REAL_MM_MIN_64 B_REAL,B_WORD
		cli
		finit
		fld		qword ptr B_REAL
		fistp	word ptr B_WORD+2
		sti  
END_T_MACRO t_normal, c_0, d_on

;........


;Prevod z DWORD do REAL primo
DEF_T_MACRO DWORD_REAL B_DWORD,B_REAL
		cli
		finit
		fild	dword ptr B_DWORD
		fstp	qword ptr B_REAL
		sti  
END_T_MACRO t_normal, c_0, d_on


;..........

;Prevod WORD na DWORD se znamenkovym rozsirenim
DEF_T_MACRO DWORD_SIG
			MOV		AX,CX				;!! ASM znamenkove rozsireni
			CWDE						;!! prevod na DWORD
			MOV		ECX,EAX				;!!
END_T_MACRO t_normal, c_0, d_on

;........

;Nahrada MSET za MSETDEB
DEF_T_MACRO MSETDEB par
			LOD		par
			STO		BUN_MSET
END_T_MACRO t_normal, c_0, d_on

;........


;Nahrada MSET1 za MSET1DB
DEF_T_MACRO MSET1DB par
			LOD		par
			STO1	BUN_MSET
END_T_MACRO t_normal, c_0, d_on

;........

;Definice uzivatelske instrukce REG_FILTER

;Filtr 1.radu  
;y(n) = (x(n)-y(n-1))*F + y(n-1) 
;Vstup: 	DR	...	x(n)	... DWORD 
;       	p1  ... F 		... DWORD v 1/1000 (0 nebo 1000 = filtr vyrazen)
;Vystup:	DR	... y(n) 	... DWORD		
;(stavova promena filtru FILTR_Ym)

DEF_T_MACRO REG_FILTER p1,pam
	T_LOCAL REG_F_E,REG_F_KL,REG_F_1
			STO		DWRD.TREG_POM
			cli
			finit
			fild	dword ptr TREG_POM
			fsub	qword ptr pam	;floating point
			fmul	qword ptr p1			;floating point
			fadd	qword ptr pam
			fst		qword ptr pam
			fistp	qword ptr TREG_POM
			wait
			sti
			lodq	TREG_POM
			or		edx,edx					;test znamenka
			jns		REG_F_KL
			negq
			cmpq	MAXDWORD			;test na limit pro zaporne
			jb		REG_F_1
			LOD		CNST.080000001H
			JUM		REG_F_E

REG_F_KL:	cmpq	MAXDWORD			;test na limit pro kladne
			jb		REG_F_1
			LOD		CNST.07FFFFFFFH
			JUM		REG_F_E

REG_F_1:	LOD		DWRD.TREG_POM	
REG_F_E:
END_T_MACRO T_NORMAL, C_0, D_ON

;.........

;Normovani - omezeni, meritko (0-1000)			
DEF_T_MACRO NORM_ANALOG  limit
     T_LOCAL NORM_1,NORM_E,NORM_2
			GE		DWRD.DW80000000		;je zaporne ?
			JL1		NORM_1
			GE		DWRD.limit			;omezeni?
			JL1		NORM_2
			JUM		NORM_E	
NORM_2:		LOD		DWRD.limit			;omezeni
     		JUM		NORM_E		
NORM_1:  	LOD		CNST.0   
NORM_E:		MULB	DWRD.DW1000
			DIVB	DWRD.limit
END_T_MACRO T_NORMAL, C_0, D_ON

;.........     